%msg20000809
%QDMC+
%Extended version of QDMC described in Gjerstad(1997) and Garcia(1995)



cd m:/Diplom2000/Matlab/MPC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Process - oppgave A
ferdig=0;
%Tar inn stepresponsen fr Hysys
load steppius_ny
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Step response model

Mfull =100;        %"Model horizon - steady state"
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Controller - QDMC

yr0    =[0.01626;5.073e-4];   %Setpoints
ur0    =[84.5;19.1];    %Ideal values
yr     =yr0;
ur     =ur0;
u0    =[84.5;19.1];          %Input reference to deviation variable
d0    =[155;78.1];          %Disturbance reference to deviation variable          
y0    =[0.01626;5.073e-4];          %Measurement reference to deviation variable    
M     =80;          %"Model horizon"
N     =30;          %Control horizon
P     =N+M-1;       %Prediction horizon
n1    =10;          %Start constraint horizon
n2    =20;          %End constraint horizon
gamma =[5;5];       %Dynamic opt. output weights
sigma =[0;0];       %Dynamic opt. input weights
lambda=[0.001;0.001];       %Dynamic opt. input change weights
q1    =[0.001;0.001];       %Steady-state opt. weights - ideal values
q2    =[5;5];       %Steady-state opt. weights - setpoints
q3a   =[1;1];       %Steady-state opt. weights - upper output constraints
q3b   =[1;1];       %Steady-state opt. weights - lower output constraints
umin  =[80;14.1];       %Min. input value
umax  =[90;24.1];   %Max. input value 
ymin  =[0.0160;4.5e-4];     %Min. output value
ymax  =[0.0166;5.5e-4];     %Max. output value
dumin =[-5;-5]; %Min. change in input value
dumax =[5;5];   %Max. change in input value 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Simulation - closed loop

global Y    %measurements
plotpred=0; %0:No open-loop prediction plot 1: Open-loop prediction plot
linear=1;   %0:nonlinear, 1:linear  
ntime=25;   %simulation time

%initial conditions
uk=u0;
duk=[0;0]; uk=uk+duk;
dk=d0;
dkold=d0;
ddk=[0;0]; dk=dk+ddk;

yk=y0;

%initialization
dUK=[];
T=0;
i=0;
U=uk; D=d0;  Y1=yk;
Ur=ur; Umax=umax; Umin=umin;
Yr=yr; Ymax=ymax; Ymin=ymin;

%qdmc_init;
[YS,AS,ASD,H,E,E1,F,G,Gd,H1,Aeq1,A1,H2,Aeq2,A2,H3,Aeq3,A3,Iu,Iy,Ic,Is0,Is1,Is2]=qdmc_init(u0,d0,y0,Ystep,M,N,P,n1,n2,gamma,sigma,lambda,q1,q2,q3a,q3b);
